## med-fichier 4.0.0+repack

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.10 FATAL_ERROR)
PROJECT(MEDFile C CXX)

## The following signature is still buggy as of CMake 2.8.11 - 
## the OPTIONAL is not considered.
## See http://www.cmake.org/Bug/view.php?id=10227
#ENABLE_LANGUAGE(Fortran OPTIONAL)

INCLUDE(CheckLanguage)
CHECK_LANGUAGE(Fortran)
IF(CMAKE_Fortran_COMPILER)
  ENABLE_LANGUAGE(Fortran)
ELSE()
  MESSAGE(STATUS "No Fortran support")
ENDIF()

## Version number 
SET(MED_NUM_MAJEUR  4)
SET(MED_NUM_MINEUR  0)
SET(MED_NUM_RELEASE 0)

## Previous version
SET(MED_3_LATEST_MINOR 3)

SET(MED_STR_VERSION "${MED_NUM_MAJEUR}.${MED_NUM_MINEUR}.${MED_NUM_RELEASE}")

SET(LONG_OR_INT int)

## User options:
OPTION (MEDFILE_BUILD_TESTS "Build MED-file tests" ON)
IF (MEDFILE_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()
OPTION (MEDFILE_BUILD_SHARED_LIBS "Build MED-file shared libraries" ON)
OPTION (MEDFILE_BUILD_STATIC_LIBS "Build MED-file static libraries" OFF)
OPTION (MEDFILE_INSTALL_DOC "Install pre-built documentation" ON)
OPTION (MEDFILE_BUILD_PYTHON "Build Python bindings (needs SWIG)" OFF)

#-- Add an Option to toggle the generation of the API documentation
#-- Embedded documentation contains patched doxygen generated fortran documention
#-- If you rebuild it with your own doxygen Fortran documentation will differ
option(MEDFILE_BUILD_DOC "Use Doxygen to create the HTML based API documentation" OFF)
if(MEDFILE_BUILD_DOC)
  FIND_PACKAGE(Doxygen)
  if (NOT DOXYGEN_FOUND)
    message(FATAL_ERROR
      "Doxygen is needed to build the documentation. Please install it correctly")
  endif()

  ADD_SUBDIRECTORY(doc)
endif()

# Option checking.
IF(MEDFILE_BUILD_SHARED_LIBS AND MEDFILE_BUILD_STATIC_LIBS)
  MESSAGE(FATAL_ERROR "You can not build shared and static libraries at the same time! ")
  SET(MEDFILE_BUILD_STATIC_LIBS OFF)
ENDIF()
IF(NOT (MEDFILE_BUILD_SHARED_LIBS OR MEDFILE_BUILD_STATIC_LIBS))
  MESSAGE(FATAL_ERROR "You must select to build either STATIC or SHARED libs")
  SET(MEDFILE_BUILD_SHARED_LIBS ON)
ENDIF()

## Useful macros
LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/config/cmake_files")
INCLUDE(medMacros)

## Version number
#MED_EXTRACT_AUTOTOOLS_VERSION(${PROJECT_SOURCE_DIR}/configure.ac MED_NUM_MAJEUR MED_NUM_MINEUR MED_NUM_RELEASE)
#SET(MED_STR_VERSION "${MED_NUM_MAJEUR}.${MED_NUM_MINEUR}.${MED_NUM_RELEASE}")

## Platform specific flags (windows)
IF(WIN32)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)  # To disable windows warnings for strcpy, fopen, ...
  ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)  # To disable windows warnings std::copy, std::transform, ...
  ADD_DEFINITIONS(-DWNT -DWIN32)
  ADD_DEFINITIONS(-D_WIN32_WINNT=0x0500) # Windows 2000 or later API is required
  ADD_DEFINITIONS(-DPPRO_NT_CALL) # For windows system functions call

  IF(NOT MINGW)
    # Needed to avoid a seg fault at runtime!
    # The variable is not very well documented but seems to exist
    SET(CMAKE_Fortran_FLAGS  "/iface:mixed_str_len_arg ${CMAKE_Fortran_FLAGS}")
    ADD_DEFINITIONS(-DPPRO_NT) # For windows medfile function nammes
  ENDIF()

ELSE()
  # Ensure intermediate OBJECT libraries and static libs are built with -fPIC:
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
ENDIF(WIN32)

## Directories
IF(WIN32 AND NOT CYGWIN)
   SET(INSTALL_CMAKE_CONFIG_DIR cmake)
ELSE()
   SET(INSTALL_CMAKE_CONFIG_DIR share/cmake/med-fichier-${MED_STR_VERSION})
ENDIF()
SET(INSTALL_INCLUDE_DIR include)

## Pre-requisites detection
# Detect HDF5 first to potentially retrieve MPI automatically:
MED_FIND_HDF5()
MED_FIND_MPI()

IF(MEDFILE_BUILD_PYTHON)
  FIND_PACKAGE(SWIG REQUIRED)
  INCLUDE(${SWIG_USE_FILE})
  FIND_PACKAGE(PythonLibs REQUIRED)
  FIND_PACKAGE(PythonInterp REQUIRED)  # to get version string ...
ENDIF()

## Creation of files med_config.h.cmake
MED_CREATE_CONFIG_FILES()

## Check for various functions
MED_CHECK_HEADERS()
MED_CHECK_FUNCTIONS()
MED_CHECK_SIZE()
MED_C_FORTRAN_INTERFACE()
MED_TIME_SYS_TIME()

## Configure the files created above
CONFIGURE_FILE("${PROJECT_BINARY_DIR}/include/med_config.h.cmake" "${PROJECT_BINARY_DIR}/include/med_config.h")
CONFIGURE_FILE("${PROJECT_BINARY_DIR}/include/2.3.6/med_config.h.cmake" "${PROJECT_BINARY_DIR}/include/2.3.6/med_config.h")

## Sources 
ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(tools)
IF(MEDFILE_BUILD_TESTS)
  ADD_SUBDIRECTORY(tests)
ENDIF()
IF(MEDFILE_BUILD_PYTHON)
  ADD_SUBDIRECTORY(python)
ENDIF()

## Installation of the doc
IF(MEDFILE_INSTALL_DOC  OR MEDFILE_BUILD_DOC)
  INSTALL(DIRECTORY doc/html.dox/ DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/med-fichier-${MED_STR_VERSION} REGEX "Makefile*" EXCLUDE PATTERN "*.am" EXCLUDE)
  INSTALL(DIRECTORY doc/gif doc/jpg doc/png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/med-fichier-${MED_STR_VERSION} FILES_MATCHING PATTERN "*.gif" PATTERN "*.jpg" PATTERN "*.svg" PATTERN "*.png")
ENDIF()

#######################
## Configuration export
#######################
INCLUDE(CMakePackageConfigHelpers)

# Project name, upper case
STRING(TOUPPER ${PROJECT_NAME} PROJECT_NAME_UC)

# Detect if we are built as a sub-project in a bigger source tree:
IF("${CMAKE_SOURCE_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}")
  SET(_BUILT_AS_SUB FALSE)
  MESSAGE(STATUS "Configuring ${PROJECT_NAME} standalone.")
ELSE()
  MESSAGE(STATUS "Configuring ${PROJECT_NAME} as a sub-project. No conf files will be installed.")
  SET(_BUILT_AS_SUB TRUE)
ENDIF()

# Add all targets to the build-tree export set if we are *not*  
# built as a sub-folder of a bigger project.
IF(NOT _BUILT_AS_SUB)
  IF(CMAKE_Fortran_COMPILER_WORKS)
    SET(_fortLib med medfwrap)
    SET(_fortLibS med_static medfwrap_static)
  ELSE()
    SET(_fortLib "")
    SET(_fortLibS "")
  ENDIF()
  
  IF(MEDFILE_BUILD_STATIC_LIBS)
    EXPORT(TARGETS medC_static ${_fortLibS}
      FILE ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake)
  ENDIF()
  IF(MEDFILE_BUILD_SHARED_LIBS) 
    EXPORT(TARGETS medC ${_fortLib}
      APPEND FILE ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake)
  ENDIF()
  
ENDIF()

# Create the configuration files:
#   - in the build tree:
SET(HDF5_ROOT_DIR "${HDF5_ROOT_DIR}")  # ensure the var exists, even if blank
SET(MPI_ROOT_DIR "${MPI_ROOT_DIR}")    # ensure the var exists, even if blank
SET(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include" "${PROJECT_BINARY_DIR}/include")
CONFIGURE_PACKAGE_CONFIG_FILE(config/cmake_files/${PROJECT_NAME}Config.cmake.in 
    ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
    INSTALL_DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}"
    PATH_VARS CONF_INCLUDE_DIRS INSTALL_CMAKE_CONFIG_DIR CMAKE_INSTALL_PREFIX HDF5_ROOT_DIR MPI_ROOT_DIR)

#   - in the install tree:
#       Get the relative path of the include directory so 
#       we can register it in the generated configuration files:
SET(CONF_INCLUDE_DIRS "${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR}")
CONFIGURE_PACKAGE_CONFIG_FILE(config/cmake_files/${PROJECT_NAME}Config.cmake.in 
    ${PROJECT_BINARY_DIR}/to_install/${PROJECT_NAME}Config.cmake
    INSTALL_DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}"
    PATH_VARS CONF_INCLUDE_DIRS INSTALL_CMAKE_CONFIG_DIR CMAKE_INSTALL_PREFIX HDF5_ROOT_DIR MPI_ROOT_DIR)

WRITE_BASIC_PACKAGE_VERSION_FILE(${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
    VERSION ${MED_STR_VERSION}
    COMPATIBILITY AnyNewerVersion)
  
# Install the CMake configuration files:
INSTALL(FILES
  "${PROJECT_BINARY_DIR}/to_install/${PROJECT_NAME}Config.cmake"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}")

# Install the export set for use within the install-tree
IF(NOT _BUILT_AS_SUB)
  INSTALL(EXPORT medfileTargets DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}" FILE ${PROJECT_NAME}Targets.cmake)
ENDIF()

=== include/CMakeLists.txt ===
ADD_SUBDIRECTORY(2.3.6)

CONFIGURE_FILE(med.h.in ${CMAKE_CURRENT_BINARY_DIR}/med.h @ONLY)
CONFIGURE_FILE(med_utils.h.in ${CMAKE_CURRENT_BINARY_DIR}/med_utils.h @ONLY)
CONFIGURE_FILE(med_parameter.hf.in ${CMAKE_CURRENT_BINARY_DIR}/med_parameter.hf @ONLY)

CONFIGURE_FILE(H5public_extract.h.in ${CMAKE_CURRENT_BINARY_DIR}/H5public_extract.h @ONLY)

SET(medC_HEADERS_H
  ${CMAKE_CURRENT_BINARY_DIR}/med.h
  ${CMAKE_CURRENT_BINARY_DIR}/med_utils.h
  medlibrary.h
  medfile.h
  medmesh.h
  medfamily.h
  medfield.h
  medprofile.h
  medlocalization.h
  medparameter.h
  medequivalence.h
  medinterp.h
  medfilter.h
  medsubdomain.h
  medstructelement.h
  medlink.h
  med_err.h
  med_exit_if.h
  med_proto.h
  medC_win_dll.h
  MEDerreur.hxx
)

SET(medF_HEADERS_H
  med.hf    
  med.hf77
  med.hf90
  ${CMAKE_CURRENT_BINARY_DIR}/med_parameter.hf
)

INSTALL(FILES ${medC_HEADERS_H} DESTINATION ${INSTALL_INCLUDE_DIR})
INSTALL(FILES ${medF_HEADERS_H} DESTINATION ${INSTALL_INCLUDE_DIR})

=== src/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS})

# On Win platform, we need to make sure symbols are properly exported in
# the intermediary OBJECT targes built in the sub-directories:
# The definition "-D<target>_EXPORTS" is normally added automatically by CMake
# when building Win DLL,
# but this doesn't work when using intermediary targets (ADD_LIBRARY(... OBJECT ...)
IF(WIN32)
  ADD_DEFINITIONS(-DmedC_EXPORTS)
ENDIF()
  
# Specific include logic - see CMakeLists.txt inside:
ADD_SUBDIRECTORY("2.3.6")

# Important: the following include comes AFTER the subdirectory 2.3.6
# to ensure the include works properly (2.3.6 includes are specific)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include 
    ${PROJECT_SOURCE_DIR}/include)

# Get pure C intermediary targets:
ADD_SUBDIRECTORY(hdfi)
ADD_SUBDIRECTORY(ci)
ADD_SUBDIRECTORY(misc)

IF(CMAKE_Fortran_COMPILER_WORKS)
  # Build intermediate targets _cfi, _cfi_static and _fi:
  ADD_SUBDIRECTORY(cfi)
  ADD_SUBDIRECTORY(fi)

  SET(medfort_wrap_SOURCES
    MEDiteratorsF.f 
    $<TARGET_OBJECTS:_fi236> 
    $<TARGET_OBJECTS:_fi>
    $<TARGET_OBJECTS:_cfi236> 
    $<TARGET_OBJECTS:_cfi>
  )
  
  SET(medfort_static_wrap_SOURCES
    MEDiteratorsF.f 
    $<TARGET_OBJECTS:_fi236> 
    $<TARGET_OBJECTS:_fi>
    $<TARGET_OBJECTS:_cfi236_static> 
    $<TARGET_OBJECTS:_cfi_static>
  )
ENDIF()

SET(medC_SOURCES
  MEDiterators.c
  $<TARGET_OBJECTS:_ci236>
  $<TARGET_OBJECTS:_hdfi236>
  $<TARGET_OBJECTS:_misc236>
  $<TARGET_OBJECTS:_med236>
  $<TARGET_OBJECTS:_ci>
  $<TARGET_OBJECTS:_misc>
  $<TARGET_OBJECTS:_hdfi>  
)

SET(medC_static_SOURCES
  MEDiterators.c
  $<TARGET_OBJECTS:_ci236_static>
  $<TARGET_OBJECTS:_hdfi236_static>
  $<TARGET_OBJECTS:_misc236_static>
  $<TARGET_OBJECTS:_med236_static>
  $<TARGET_OBJECTS:_ci_static>
  $<TARGET_OBJECTS:_misc_static>
  $<TARGET_OBJECTS:_hdfi_static>  
)

########################### Pure C stuff ###################################
############################################################################

### Installation preparation:
SET(_export_group "medfileTargets")

######### Shared Libraries ##########
IF(MEDFILE_BUILD_SHARED_LIBS)
  ADD_LIBRARY(medC SHARED ${medC_SOURCES})
  SET_TARGET_PROPERTIES(medC PROPERTIES
    VERSION   11.0.0
    SOVERSION 11.0.0)
  TARGET_LINK_LIBRARIES(medC ${HDF5_LIBS} ${MPI_LIBS})
  MED_SET_DEFINITIONS(medC NOGDI)
  
  INSTALL(TARGETS medC EXPORT ${_export_group} DESTINATION lib)  
ENDIF()

######### Static Libraries ##########
##
## Target names are suffixed with "_static" but file 
## names remain the same.
 
IF(MEDFILE_BUILD_STATIC_LIBS)
  ADD_LIBRARY(medC_static STATIC ${medC_SOURCES})
  SET_TARGET_PROPERTIES(medC_static PROPERTIES OUTPUT_NAME medC)
  TARGET_LINK_LIBRARIES(medC_static ${HDF5_LIBS} ${MPI_LIBS})
  MED_SET_DEFINITIONS(medC_static NOGDI)
  
  INSTALL(TARGETS medC_static EXPORT ${_export_group} DESTINATION lib)
ENDIF()

########################### Fortran stuff ###################################
#############################################################################
IF(CMAKE_Fortran_COMPILER_WORKS)
  
  ######### Shared Libraries ##########
  IF(MEDFILE_BUILD_SHARED_LIBS)
    ## Intermediate library - this is unavoidable 
    ## if we want the Fortran wrapper to build correctly under win.
    ADD_LIBRARY(medfwrap SHARED ${medfort_wrap_SOURCES})
    SET_TARGET_PROPERTIES(medfwrap PROPERTIES
      VERSION   11.0.0
      SOVERSION 11.0.0)
    TARGET_LINK_LIBRARIES(medfwrap medC)
    INSTALL(TARGETS medfwrap EXPORT medfileTargetsF DESTINATION lib)

    # Add Shared MED library
    ADD_LIBRARY(med SHARED MEDiterators.c)
    SET_TARGET_PROPERTIES(med PROPERTIES
      VERSION   11.0.0
      SOVERSION 11.0.0)
    TARGET_LINK_LIBRARIES(medfwrap medC)
    TARGET_LINK_LIBRARIES(med medfwrap)    
   
    # Install only the resulting library:
    INSTALL(TARGETS med EXPORT medTargetsF DESTINATION lib)
  ENDIF()

  ######### Static Libraries ##########
  ##
  ## Target names are suffixed with "_static" but file 
  ## names remain the same.
  IF(MEDFILE_BUILD_STATIC_LIBS)
    ## Intermediate library - this is unavoidable 
    ## if we want the Fortran wrapper to build correctly under win.
    ADD_LIBRARY(medfwrap_static STATIC ${medfort_wrap_SOURCES})
    SET_TARGET_PROPERTIES(medfwrap_static PROPERTIES OUTPUT_NAME medfwrap)
    TARGET_LINK_LIBRARIES(medfwrap_static medC_static)
    INSTALL(TARGETS medfwrap_static EXPORT medfileTargetsF DESTINATION lib)
    
    # Add Static MED library
    ADD_LIBRARY(med_static STATIC MEDiterators.c)
    SET_TARGET_PROPERTIES(med_static PROPERTIES OUTPUT_NAME med)
    TARGET_LINK_LIBRARIES(med_static medfwrap_static)

    # Install only the resulting library:  
    INSTALL(TARGETS med_static EXPORT medfileTargetsF DESTINATION lib)
  ENDIF()
  
ENDIF(CMAKE_Fortran_COMPILER_WORKS)

=== src/ci/CMakeLists.txt ===
SET(ci_SOURCES
MEDmeshEntityAttributeAdvancedWr.c 
MEDmeshEntityAttributeAdvancedRd.c 
MEDmeshGeotypeName.c 
MEDmeshGeotypeParameter.c 
MEDmeshNodeCoordinateTrsfWr.c 
MEDmeshNodeCoordinateTrsfRd.c 
MEDfieldInterpInfo.c 
MEDfieldnInterp.c 
MEDfieldInterpWr.c 
MEDinterpCr.c 
MEDinterpBaseFunctionWr.c 
MEDnInterp.c 
MEDinterpInfoByName.c 
MEDinterpInfo.c 
MEDinterpBaseFunctionRd.c 
MEDinterpBaseFunctionCoeffSize.c 
MEDlibraryNumVersion.c
MEDlibraryStrVersion.c
MEDlibraryHdfNumVersion.c
MEDlibraryHdfStrVersion.c
MEDlibraryClose.c
MEDfileExist.c
MEDfileOpen.c
MEDfileVersionOpen.c
MEDfileName.c
MEDmemFileOpen.c
MEDfileClose.c 
MEDfileCommentWr.c 
MEDfileCommentRd.c 
MEDfileCompatibility.c 
MEDfileNumVersionRd.c 
MEDfileStrVersionRd.c 
MEDfileObjectsMount.c 
MEDfileObjectsMountById.c 
MEDfileObjectsUnmount.c 
MEDfileObjectExist.c
MEDnProfile.c 
MEDprofileInfo.c 
MEDprofileWr.c 
MEDprofileSizeByName.c 
MEDprofileRd.c 
MEDfilterEntityCr.c 
MEDfilterBlockOfEntityCr.c 
_MEDfieldValueAdvancedWr30.c 
_MEDfieldValueAdvancedWr33.c 
MEDfieldValueAdvancedWr.c 
MEDfieldValueWithProfileWr.c 
MEDfieldValueWr.c 
_MEDfieldValueAdvancedRd30.c 
_MEDfieldValueAdvancedRd33.c 
_MEDfieldValueAdvancedRd236.c 
MEDfieldValueAdvancedRd.c 
MEDfieldValueWithProfileRd.c 
MEDfieldValueRd.c 
MEDfieldCr.c 
MEDnField.c 
MEDfieldnComponent.c 
MEDfieldnComponentByName.c 
MEDfieldInfo.c 
MEDfieldInfoByName.c 
MEDfieldComputingStepInfo.c 
MEDfieldComputingStepMeshInfo.c 
MEDfieldComputingStepMeshWr.c 
MEDfieldnProfile.c 
_MEDfieldnValue.c 
MEDfieldnValueWithProfileByName.c 
MEDfieldnValueWithProfile.c 
MEDfieldnValue.c 
MEDlocalizationWr.c 
MEDlocalizationRd.c 
MEDnLocalization.c 
MEDlocalizationInfo.c 
MEDlocalizationInfoByName.c 
MEDlinkWr.c 
MEDlinkRd.c 
MEDnLink.c 
MEDlinkInfoByName.c 
MEDlinkInfo.c 
_MEDmeshCr.c 
MEDmeshCr.c 
MEDsupportMeshCr.c 
_MEDmeshInfoByName.c 
MEDmeshInfoByName.c 
MEDsupportMeshInfoByName.c 
MEDmeshInfo.c 
MEDsupportMeshInfo.c 
MEDnMesh.c 
MEDnSupportMesh.c 
MEDsupportMeshnAxis.c 
MEDsupportMeshnAxisByName.c 
MEDmeshGridTypeWr.c 
MEDmeshGridTypeRd.c 
MEDmeshGridIndexCoordinateWr.c 
MEDmeshGridIndexCoordinateRd.c 
MEDmeshGridStructWr.c 
MEDmeshGridStructRd.c 
MEDmeshUniversalNameWr.c 
MEDmeshUniversalNameRd.c 
MEDmeshAttributeWr.c 
MEDmeshAttributeRd.c 
MEDmeshComputationStepCr.c 
MEDmeshComputationStepInfo.c 
MEDmeshComputationStepDtRd.c 
MEDmeshNodeCoordinateWr.c 
MEDmeshNodeCoordinateWithProfileWr.c 
MEDmeshNodeCoordinateAdvancedWr.c 
MEDmeshElementConnectivityAdvancedWr.c 
MEDmeshElementConnectivityWithProfileWr.c 
MEDmeshElementConnectivityWr.c 
MEDmeshNodeCoordinateRd.c 
MEDmeshNodeCoordinateWithProfileRd.c 
MEDmeshNodeCoordinateAdvancedRd.c 
MEDmeshElementConnectivityAdvancedRd.c 
MEDmeshElementConnectivityWithProfileRd.c 
MEDmeshElementConnectivityRd.c 
_MEDmeshnEntity.c 
MEDmeshnEntityWithProfile.c 
MEDmeshnEntity.c 
MEDmeshNodeWr.c 
MEDmeshNodeRd.c 
MEDmeshElementWr.c 
MEDmeshElementRd.c 
MEDfilterAllocate.c 
MEDfilterDeAllocate.c 
MEDfilterClose.c 
_MEDmeshAdvancedWr.c 
_MEDmeshAdvancedRd.c 
MEDmeshEntityNameWr.c 
MEDmeshEntityNumberWr.c 
MEDmeshEntityFamilyNumberWr.c 
MEDmeshEntityNameRd.c 
MEDmeshEntityNumberRd.c 
MEDmeshEntityFamilyNumberRd.c 
MEDmeshnAxis.c 
MEDmeshnAxisByName.c 
MEDmeshPolygonWr.c 
MEDmeshPolygon2Wr.c 
MEDmeshPolygonRd.c 
MEDmeshPolygon2Rd.c 
MEDmeshPolyhedronWr.c 
MEDmeshPolyhedronRd.c 
MEDfamilyCr.c 
MEDnFamily.c 
MEDnFamilyGroup.c 
MEDfamilyInfo.c 
MEDnFamily23Attribute.c 
_MEDnFamily23Attribute236.c 
_MEDnFamily23Attribute30.c 
MEDfamily23Info.c 
_MEDfamily23Info236.c 
_MEDfamily23Info30.c 
_MEDmeshAssociatedGroupCr.c 
MEDmeshSortingTypeRd.c 
MEDnEquivalence.c 
MEDequivalenceCr.c 
MEDequivalenceInfo.c 
MEDequivalenceComputingStepInfo.c 
MEDequivalenceCorrespondenceWr.c 
MEDequivalenceCorrespondenceRd.c 
MEDequivalenceCorrespondenceSizeInfo.c 
MEDequivalenceCorrespondenceSize.c 
MEDsubdomainJointCr.c 
MEDnSubdomainJoint.c 
MEDsubdomainJointInfo.c 
MEDsubdomainCorrespondenceWr.c 
MEDsubdomainComputingStepInfo.c 
MEDsubdomainCorrespondenceSizeInfo.c 
MEDsubdomainCorrespondenceSize.c 
MEDsubdomainCorrespondenceRd.c 
MEDmeshGlobalNumberWr.c 
MEDmeshGlobalNumberRd.c 
MEDstructElementCr.c 
MEDstructElementConstAttWithProfileWr.c 
MEDstructElementConstAttWr.c 
MEDnStructElement.c 
MEDstructElementInfoByName.c 
MEDstructElementInfo.c 
MEDstructElementConstAttInfoByName.c 
MEDstructElementConstAttInfo.c 
MEDstructElementConstAttRd.c 
MEDstructElementAttSizeof.c  
MEDstructElementVarAttCr.c 
MEDstructElementVarAttInfoByName.c 
MEDstructElementVarAttInfo.c 
MEDmeshStructElementVarAttWr.c 
MEDmeshStructElementVarAttRd.c 
MEDstructElementName.c 
MEDstructElementGeotype.c 
_MEDmeshDatagroupOpen.c 
MEDparameterCr.c 
MEDnParameter.c 
MEDparameterInfo.c 
MEDparameterInfoByName.c 
MEDparameterValueWr.c 
MEDparameterValueRd.c 
MEDparameterComputationStepInfo.c 
MEDmeshEntityInfo.c
_MEDfieldCr31.c 
_MEDfieldCr30.c 
_MEDmeshInfoByName30.c 
_MEDmeshnAxisByName30.c 
_MEDmeshUniversalNameRd30.c 
_MEDmeshnEntity30.c 
_MEDmeshInfoByName236.c 
_MEDmeshnAxisByName236.c 
_MEDmeshUniversalNameRd236.c 
_MEDmeshnEntity236.c 
_MEDmeshAdvancedRd30.c 
_MEDmeshAdvancedRd236.c 
_MEDfilterEntityCr30.c 
_MEDfilterEntityCr236.c 
_MEDnFamily30.c 
_MEDnFamily236.c 
_MEDnFamilyGroup30.c 
_MEDnFamilyGroup236.c 
_MEDlinkRd30.c 
_MEDlinkRd236.c 
_MEDfieldComputingStepInfo30.c 
_MEDfieldComputingStepInfo31.c 
_MEDfieldComputingStepInfo236.c 
_MEDfieldComputingStepMeshInfo30.c 
_MEDfieldComputingStepMeshInfo31.c 
_MEDfieldComputingStepMeshInfo236.c 
_MEDfieldComputingStepCheck236.c 
_MEDfieldInfoByName30.c 
_MEDfieldInfoByName236.c 
_MEDfieldnProfile30.c 
_MEDfieldnProfile236.c 
_MEDfieldnValue30.c 
_MEDfieldnValue236.c 
_MEDprofileRd30.c 
_MEDprofileRd236.c 
_MEDlocalizationRd30.c 
_MEDlocalizationRd236.c 
_MEDlocalizationInfoByName30.c 
_MEDlocalizationInfoByName236.c 
_MEDnEquivalence30.c 
_MEDnEquivalence236.c 
_MEDequivalenceInfo30.c 
_MEDequivalenceInfo236.c 
_MEDequivalenceCorrespondenceSize30.c 
_MEDequivalenceCorrespondenceSize236.c 
_MEDequivalenceCorrespondenceWr33.c 
_MEDequivalenceCorrespondenceWr30.c 
_MEDequivalenceCorrespondenceRd33.c 
_MEDequivalenceCorrespondenceRd30.c 
_MEDequivalenceCorrespondenceRd236.c 
_MEDequivalenceComputingStepInfo30.c 
_MEDequivalenceComputingStepInfo236.c 
_MEDequivalenceCorrespondenceSizeInfo30.c 
_MEDequivalenceCorrespondenceSizeInfo236.c 
_MEDmeshComputationStepInfo30.c 
_MEDmeshComputationStepInfo236.c 
_MEDmeshGridIndexCoordinateRd30.c 
_MEDmeshGridIndexCoordinateRd236.c 
_MEDnSubdomainJoint30.c 
_MEDnSubdomainJoint236.c 
_MEDsubdomainJointInfo30.c 
_MEDsubdomainJointInfo236.c 
_MEDsubdomainCorrespondenceSize30.c 
_MEDsubdomainCorrespondenceSize236.c 
_MEDsubdomainCorrespondenceRd30.c 
_MEDsubdomainCorrespondenceRd236.c 
_MEDsubdomainComputingStepInfo30.c 
_MEDsubdomainComputingStepInfo236.c 
_MEDsubdomainCorrespondenceSizeInfo30.c 
_MEDsubdomainCorrespondenceSizeInfo236.c 
_MEDparameterInfoByName30.c 
_MEDparameterInfoByName236.c 
_MEDparameterValueRd30.c 
_MEDparameterValueRd236.c 
_MEDfileCommentRd30.c 
_MEDfileCommentRd236.c 
_MEDfileObjectsMount30.c 
_MEDfileObjectsMount236.c 
_MEDfileObjectsUnmount30.c 
_MEDfileObjectsUnmount236.c 
_MEDfield23ComputingStepMeshInfo30.c 
_MEDfield23ComputingStepMeshInfo31.c 
_MEDfield23ComputingStepMeshInfo236.c 
_MEDfield23nProfile30.c 
_MEDfield23nProfile236.c 
MEDfield23nValueWithProfile.c 
MEDfield23ComputingStepMeshInfo.c 
MEDfield23nProfile.c 
MEDfield23ValueWithProfileRd.c 
_MEDfield23nValue.c 
_MEDfield23nValue30.c 
_MEDfield23nValue236.c 
_MEDmeshEntityInfo30.c 
  _MEDmeshEntityInfo236.c
  _MEDfamilyInfo32.c
  _MEDnFamilyGroup32.c
  _MEDfamilyCr30.c
  _MEDfamilyCr32.c
  _MEDfamilyInfo30.c)

IF(MEDFILE_USE_MPI)
  LIST(APPEND ci_SOURCES MEDparFileOpen.c)
ENDIF(MEDFILE_USE_MPI)

# Intermediary targets
ADD_LIBRARY(_ci OBJECT ${ci_SOURCES})

ADD_LIBRARY(_ci_static OBJECT ${ci_SOURCES})
MED_SET_DEFINITIONS(_ci_static MED3_USESTATIC)

=== src/hdfi/CMakeLists.txt ===
SET(hdfi_SOURCES 
    MEDattrFermer.c
    _MEDattributeExist.c
    _MEDattributeNumRdByName.c
    _MEDattributeNumWrByName.c
    _MEDattributeNumWr.c
    _MEDattributeStringRdByName.c
    _MEDattributeStringWrByName.c
    _MEDattributeStringWr.c
    MEDattrNumLire.c
    MEDattrOuvrir.c
    MEDattrStringLire.c
    _MEDcheckAttributeStringFin.c
    _MEDcheckAttributeStringFunc.c
    _MEDcheckAttributeStringInit.c
    _MEDchecknSublinkFunc.c
    _MEDcopyName.c
    MEDdatagroupCreer.c
    _MEDdatagroupCrOrderCr.c
    _MEDdatagroupExist.c
    MEDdatagroupFermer.c
    MEDdatagroupLienCreer.c
    MEDdatagroupLienSupprimer.c
    _MEDdatagroupOpen.c
    MEDdatagroupOuvrir.c
    _MEDdatasetExistByMedtype.c
    _MEDdatasetExist.c
    MEDdatasetFermer.c
    MEDdatasetOuvrir.c
    _MEDdatasetRd.c
    _MEDdatasetWr.c
    MEDfichierDemonter.c
    MEDfichierFermer.c
    MEDfichierMonter.c
    MEDfichierNo.c
    _MEDfileCreate.c
    _MEDfileName.c
    _MEDfileOpen.c
    _MEDfilterBlockOfEntityFullICompactCr.c
    _MEDfilterBlockOfEntityFullIGlobalCr.c
    _MEDfilterBlockOfEntityNoICompactCr.c
    _MEDfilterBlockOfEntityNoIGlobalCr.c
    _MEDfilterEntityFullICompactCr.c
    _MEDfilterEntityFullIGlobalCr.c
    _MEDfilterEntityNoICompactCr.c
    _MEDfilterEntityNoIGlobalCr.c
    _MEDgetComputationStepName.c
    _MEDgetDatasetChgt.c
    _MEDisasoftlink.c
    _MEDiterate.c
    _MEDlinkObjs.c
    _MEDmemFileOpen.c
    MEDmodeErreurVerrouiller.c
    _MEDnObjects.c
    _MEDobjectCrOrderGetName.c
    __MEDobjectGetName.c
    _MEDobjectGetName.c
    _MEDobjectGetRank.c
    MEDobjetsOuverts.c
    _MEDselectAllEntitiesFullI.c
    _MEDselectAllEntitiesNoI.c
    _MEDsoftlinkDel.c
    _MEDvisit.c
)

IF(MEDFILE_USE_MPI)
  LIST(APPEND hdfi_SOURCES _MEDparFileOpen.c _MEDparFileCreate.c)
ENDIF(MEDFILE_USE_MPI)
  
ADD_LIBRARY(_hdfi OBJECT ${hdfi_SOURCES})
 
ADD_LIBRARY(_hdfi_static OBJECT ${hdfi_SOURCES})
MED_SET_DEFINITIONS(_hdfi_static MED3_USESTATIC)

=== src/misc/CMakeLists.txt ===
SET(misc_SOURCES
  MEDsetFilter.c
  MEDcstring.c
  MED1cstring.c
  MED2cstring.c
  MEDcstringFree.c
  MEDfstring.c
  _MEDc2fString.c
  MEDexitIf.c
  MEDversionedApi3.cxx
  MEDgetGeometryTypeFromName.cxx
  MEDversionedApi3C.c
  MEDmodeAcces.cxx
  MEDmodeAccesC.c
  MEDerreur.cxx
  MEDfieldChecked.cxx
  MEDfileVersion.cxx
  _MEDgetGeometricParameter.c
  _MEDgetDynGeometricParameter.c
  _MEDgetDatasetName.c
  _MEDgetDatasetParameter.c
  _MEDgetDatatype.c
  _MEDmeshtypeCompatibility.c
  _MEDgetEntityTypeName.c
  _MEDgetFieldEntityGeoTypeName.c
  _MEDgetInternalGeometryTypeName.c
  _MEDgetInternalGeometryTypeName30.c
  _MEDgetInternalGeometryTypeName33.c
  _MEDgetExternalGeometryTypeName.c
  _MEDcheckVersion30.c
  _MED23v30stringConvert.c
  _MEDgetSupportMeshNbOfEntities.c
  )
  
ADD_LIBRARY(_misc OBJECT ${misc_SOURCES})

ADD_LIBRARY(_misc_static OBJECT ${misc_SOURCES})
MED_SET_DEFINITIONS(_misc_static MED3_USESTATIC)

=== tests/c/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS}
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/include
)

SET(testc_SOURCES test1.c test2.c test3.c test4.c test5.c 
    test6.c test7.c test8.c test9.c test10.c test10_mem.c
    test10_f32_i32.c test10_f32_i64.c test10_f32.c test10_i32.c test10_i64.c
    test11.c test11b.c 
    test12.c test13.c test14.c test15.c test16.c test17.c test18.c 
    test20.c test21.c test22.c test23.c test24.c test25.c test26.c test27.c 
    test28.c test29.c test30.c test31.c test32.c test33.c)

SET(testc_NOT_AUTO_LAUNCH test13 test15 test30 test31 test32 test33)

# Test20 needs files from dumps.ref:
FILE(COPY "dumps.ref/test2-med.hdf" DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
FILE(COPY "dumps.ref/test10-med.hdf" DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

FOREACH(testc_SOURCE ${testc_SOURCES})
  GET_FILENAME_COMPONENT(testc_BASE ${testc_SOURCE} NAME_WE)
  LIST(FIND testc_NOT_AUTO_LAUNCH ${testc_BASE} IS_STDALONE_TEST)
  # Shared lib tests
  IF(MEDFILE_BUILD_SHARED_LIBS)
    SET(testc_SHARED_BIN "${testc_BASE}c")
    ADD_EXECUTABLE(${testc_SHARED_BIN} ${testc_SOURCE})
    TARGET_LINK_LIBRARIES(${testc_SHARED_BIN} medC)
    SET_TARGET_PROPERTIES(${testc_SHARED_BIN} PROPERTIES OUTPUT_NAME ${testc_BASE})
    GET_TARGET_PROPERTY(TMP ${testc_SHARED_BIN} OUTPUT_NAME)
    INSTALL(TARGETS ${testc_SHARED_BIN} DESTINATION bin/testc)
    IF(${IS_STDALONE_TEST} EQUAL -1)
      ADD_TEST("Test${testc_SHARED_BIN}" ${TMP})
    ENDIF(${IS_STDALONE_TEST} EQUAL -1)
  ENDIF()
  
  IF(MEDFILE_BUILD_STATIC_LIBS)
    # Static lib tests
    SET(testc_STATIC_BIN "${testc_BASE}c_static")
    ADD_EXECUTABLE(${testc_STATIC_BIN} ${testc_SOURCE})    
    TARGET_LINK_LIBRARIES(${testc_STATIC_BIN} medC_static)
    MED_SET_DEFINITIONS(${testc_STATIC_BIN} MED3_USESTATIC)
    SET_TARGET_PROPERTIES(${testc_STATIC_BIN} PROPERTIES OUTPUT_NAME "${testc_BASE}_static")
    GET_TARGET_PROPERTY(TMP ${testc_STATIC_BIN} OUTPUT_NAME)
    INSTALL(TARGETS ${testc_STATIC_BIN} DESTINATION bin/testc)
  ENDIF()
  
  # Other
  IF(${IS_STDALONE_TEST} EQUAL -1)
    ADD_TEST("Test${testc_STATIC_BIN}" ${TMP})
  ENDIF(${IS_STDALONE_TEST} EQUAL -1)
ENDFOREACH(testc_SOURCE ${testsc_BINARIES})

=== tests/f/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/include
)

ADD_DEFINITIONS(-DTEST10_FILENAME=\"test10f.med\")

SET(testf_SOURCES 
    test10f.f
#    test11b.f90   
#    test11.f90   
    test12.f
    test13.f90
    test14.f
    test15.f90
    test16.f
    test17.f90
    test18.f
    test1.f
#    test20.f     ##  more complex logic for this one -- see autotools procedure.  
    test21.f
    test22.f
    test23.f
    test24.f
    test25.f
    test26.f
    test27.f
    test28.f
    test29.f
    test2.f
    test30.f90
    test31.f
    test32.f
    test33.f
    test3.f
    test4.f
    test5.f90
    test6.f
    test7.f90
    test8.f
    test9.f90
)  

SET(testf_10
    test10.F90
    test10_f32.F90
    test10_f32_i32.F90
    test10_f32_i64.F90
    test10_i32.F90
    test10_i64.F90
)

LIST(APPEND testf_SOURCES ${testf_10})

# test10* need specific definitions
FOREACH(testf_SRC ${testf_10})
    GET_FILENAME_COMPONENT(_shortName ${testf_SRC} NAME_WE) 
    SET_SOURCE_FILES_PROPERTIES(${testf_SRC} COMPILE_DEFINTIONS TEST10_FILENAME=\"${_shortName}.med\")
ENDFOREACH()

# Some tests need files from dumps.ref:
#FILE(COPY "../c/dumps.ref/test10.med" DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
#FILE(COPY "dumps.ref/test11f.med" DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
#FILE(COPY "dumps.ref/test11f.med" DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

FOREACH(testf_SOURCE ${testf_SOURCES})
  GET_FILENAME_COMPONENT(testf_BASE ${testf_SOURCE} NAME_WE)
  # Shared lib tests
  IF(MEDFILE_BUILD_SHARED_LIBS)
    SET(testf_SHARED_BIN "${testf_BASE}f")
    ADD_EXECUTABLE(${testf_SHARED_BIN} ${testf_SOURCE})
    TARGET_LINK_LIBRARIES(${testf_SHARED_BIN} med)
    SET_TARGET_PROPERTIES(${testf_SHARED_BIN} PROPERTIES OUTPUT_NAME ${testf_BASE})
    GET_TARGET_PROPERTY(TMP ${testf_SHARED_BIN} OUTPUT_NAME)
    INSTALL(TARGETS ${testf_SHARED_BIN} DESTINATION bin/testf)
    ADD_TEST("Test${testf_SHARED_BIN}" ${TMP})
  ENDIF()
  
  # Static lib tests
  IF(MEDFILE_BUILD_STATIC_LIBS)
    SET(testf_STATIC_BIN "${testf_BASE}f_static")
    ADD_EXECUTABLE(${testf_STATIC_BIN} ${testf_SOURCE})
    TARGET_LINK_LIBRARIES(${testf_STATIC_BIN} med_static)
    SET_TARGET_PROPERTIES(${testf_STATIC_BIN} PROPERTIES OUTPUT_NAME "${testf_BASE}_static")
    GET_TARGET_PROPERTY(TMP ${testf_STATIC_BIN} OUTPUT_NAME)
    INSTALL(TARGETS ${testf_STATIC_BIN} DESTINATION bin/testf)
    ADD_TEST("Test${testf_STATIC_BIN}" ${TMP})
  ENDIF()
    
ENDFOREACH(testf_SOURCE ${testsf_BINARIES})

=== tools/mdump/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS}
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/include
)

SET(mdump2_SOURCES 
  mdump2.c 
  MED23meshIterators.c 
  MED23fieldIterators.c
  )
  
SET(mdump3_SOURCES 
  mdump3.c 
  MED23meshIterators.c 
  MED23fieldIterators.c
 )

ADD_EXECUTABLE(mdump2 ${mdump2_SOURCES})
TARGET_LINK_LIBRARIES(mdump2 ${MEDFILE_ENGINE_LIB})

ADD_EXECUTABLE(mdump3 ${mdump3_SOURCES})
TARGET_LINK_LIBRARIES(mdump3 ${MEDFILE_ENGINE_LIB})

INSTALL(TARGETS mdump2 DESTINATION bin)
INSTALL(TARGETS mdump3 DESTINATION bin)

# Configure and install xmdump

SET(prefix ${CMAKE_INSTALL_PREFIX})
CONFIGURE_FILE(xmdump2.in ${PROJECT_BINARY_DIR}/xmdump2 @ONLY)
CONFIGURE_FILE(xmdump3.in ${PROJECT_BINARY_DIR}/xmdump3 @ONLY)

INSTALL(PROGRAMS ${PROJECT_BINARY_DIR}/xmdump2 ${PROJECT_BINARY_DIR}/xmdump3 DESTINATION bin)
INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink mdump3 mdump WORKING_DIRECTORY ${DESTDIR}${CMAKE_INSTALL_PREFIX}/bin)")
INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink xmdump3 xmdump WORKING_DIRECTORY ${DESTDIR}${CMAKE_INSTALL_PREFIX}/bin)")

=== tools/medimport/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS}
)

# Needed by all targets:
ADD_DEFINITIONS(-DMED_MESGERR_FOR_TOOLS)
INCLUDE_DIRECTORIES(include)

# Those two need specific includes:
ADD_SUBDIRECTORY("2.1.x")
ADD_SUBDIRECTORY("2.3.1")

# For the rest:
INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}/include"
    "${PROJECT_SOURCE_DIR}/include")

ADD_SUBDIRECTORY("2.3.6")
ADD_SUBDIRECTORY("3.0.0")
ADD_SUBDIRECTORY("3.1.0")
ADD_SUBDIRECTORY("3.2.0")

SET(medimporttop_SOURCES
  libmedimport.c
  MAJ_version.c
)

SET(medimport_SOURCES
  $<TARGET_OBJECTS:_medimport21x>
  $<TARGET_OBJECTS:_medimport231>
  $<TARGET_OBJECTS:_medimport236>
  $<TARGET_OBJECTS:_medimport300>
  $<TARGET_OBJECTS:_medimport310>
  $<TARGET_OBJECTS:_medimport320>
  ${medimporttop_SOURCES}
)

SET(medimport_static_SOURCES
  $<TARGET_OBJECTS:_medimport21x_static>
  $<TARGET_OBJECTS:_medimport231_static>
  $<TARGET_OBJECTS:_medimport236_static>
  $<TARGET_OBJECTS:_medimport300_static>
  $<TARGET_OBJECTS:_medimport310_static>
  $<TARGET_OBJECTS:_medimport320_static>
  ${medimporttop_SOURCES}
)

# Shared version
IF(MEDFILE_BUILD_SHARED_LIBS)
  ADD_LIBRARY(medimportengine SHARED ${medimport_SOURCES})
  IF(WIN32)
    MED_SET_DEFINITIONS(medimportengine medimport_EXPORTS MEDIMPORTCXX_DLL_EXPORTS)
  ENDIF()
  SET_TARGET_PROPERTIES(medimportengine PROPERTIES
    VERSION   0.3.0
    SOVERSION 0.3.0)
  TARGET_LINK_LIBRARIES(medimportengine medC)
  SET_TARGET_PROPERTIES(medimportengine PROPERTIES OUTPUT_NAME medimport)
  INSTALL(TARGETS medimportengine DESTINATION lib)
  SET(_lib_to_link "medimportengine")
ENDIF()

# Static version
IF(MEDFILE_BUILD_STATIC_LIBS)
  ADD_LIBRARY(medimportengine_static STATIC ${medimport_static_SOURCES})
  TARGET_LINK_LIBRARIES(medimportengine_static medC_static)
  MED_SET_DEFINITIONS(medimportengine_static MED3_USESTATIC)
  SET_TARGET_PROPERTIES(medimportengine_static PROPERTIES OUTPUT_NAME medimport)
  INSTALL(TARGETS medimportengine_static DESTINATION lib)
  # Give precendence to the shared object for the linking of 
  # the executable medimport:
  IF(NOT _lib_to_link)
    SET(_lib_to_link "medimportengine_static")
  ENDIF()
ENDIF()

# Only build the medimport executable on certain
# conditions to avoid a nasty name conflict:
IF(NOT (WIN32 AND MEDFILE_BUILD_STATIC_LIBS))
  ADD_EXECUTABLE(medimport medimportcxx.cxx)
  IF(MEDFILE_BUILD_STATIC_LIBS)
    MED_SET_DEFINITIONS(medimport MED3_USESTATIC)
  ENDIF()
  TARGET_LINK_LIBRARIES(medimport ${_lib_to_link})
    
  # Installation
  INSTALL(TARGETS medimport DESTINATION bin )  
ENDIF()

INSTALL(FILES include/medimport_win_dll.h include/MEDimport.h include/MEDimport.hxx include/medimportcxx_win_dll.h DESTINATION include)

=== tools/medimport/2.1.x/CMakeLists.txt ===
SET(medimport21x_SOURCES
  MAJ_21_22_chaine.c
  MAJ_21_22_champs.c
  MAJ_21_22_elements_maillage.c
  MAJ_21_22_familles_maillage.c
  MAJ_21_22_localisation_Gauss.c
  MAJ_21_22_maillages.c
  MAJ_21_22_noeuds_maillage.c
  MAJ_21_22_profils.c
  MED21attrNumLire.c
  MED21datasetNumLire.c
)

# Include are specific for the 2.3.6 version - make sure they get incl first:
INCLUDE_DIRECTORIES(BEFORE 
    "${PROJECT_BINARY_DIR}/include/2.3.6"
    "${PROJECT_SOURCE_DIR}/include/2.3.6")

ADD_DEFINITIONS(-DMED_API_23)

# On Win platform, we need to make sure symbols are properly exported in
# the intermediary OBJECT targets
# The definition "-D<target>_EXPORTS" is normally added automatically by CMake
# when building Win DLL,
# but this doesn't work when using intermediary targets (ADD_LIBRARY(... OBJECT ...)
IF(WIN32)
  ADD_DEFINITIONS(-Dmedimport_EXPORTS)
ENDIF()

ADD_LIBRARY(_medimport21x OBJECT ${medimport21x_SOURCES})

ADD_LIBRARY(_medimport21x_static OBJECT ${medimport21x_SOURCES})
MED_SET_DEFINITIONS(_medimport21x_static MED3_USESTATIC)

=== tools/medimport/2.3.1/CMakeLists.txt ===
SET(medimport231_SOURCES
  MAJ_231_232_chaine.c  
  MAJ_231_232_champs.c
  MAJ_231_232_maillages.c
  MED231champInfoEtRen.c
  MED231champLireEtUnlink.c
  MED231champNormaliser.c
  MED231champRefInfoEtRenMaa.c
  MED231datasetNumEcrire.c
  MED231datasetNumLire.c
)

# Include are specific for the 2.3.6 version - make sure they get incl first:
INCLUDE_DIRECTORIES(BEFORE 
    "${PROJECT_BINARY_DIR}/include/2.3.6"
    "${PROJECT_SOURCE_DIR}/include/2.3.6")

ADD_DEFINITIONS(-DMED_API_23)

# On Win platform, we need to make sure symbols are properly exported in
# the intermediary OBJECT targets
# The definition "-D<target>_EXPORTS" is normally added automatically by CMake
# when building Win DLL,
# but this doesn't work when using intermediary targets (ADD_LIBRARY(... OBJECT ...)
IF(WIN32)
  ADD_DEFINITIONS(-Dmedimport_EXPORTS)
ENDIF()

ADD_LIBRARY(_medimport231 OBJECT ${medimport231_SOURCES})

ADD_LIBRARY(_medimport231_static OBJECT ${medimport231_SOURCES})
MED_SET_DEFINITIONS(_medimport231_static MED3_USESTATIC)

=== debian/changelog ===
med-fichier (4.0.0+repack-8) unstable; urgency=medium

  * Team upload.
  * Drop Python 2 support (Closes: #937000).
  * Enable autopkgtest-pkg-python testsuite.

 -- Ondřej Nový <onovy@debian.org>  Mon, 28 Oct 2019 14:11:27 +0100

med-fichier (4.0.0+repack-7) unstable; urgency=medium

  * Re-enable parallel test on 32 bits architectures (#918157 now fixed)
  * New patch reproducible-build.patch to improve reproducibility

 -- Gilles Filippini <pini@debian.org>  Sun, 13 Jan 2019 20:30:36 +0100

med-fichier (4.0.0+repack-6) unstable; urgency=medium

  * Temporarily disable parallel test on 32 bits architectures to
    workaround #918157

 -- Gilles Filippini <pini@debian.org>  Fri, 04 Jan 2019 13:10:20 +0100

med-fichier (4.0.0+repack-5) unstable; urgency=medium

  * Drop debian/source/lintian-overrides; these lintian tags were removed
    in 2012
  * libmedc?11: Breaks / Replaces libmedc?1v5 (= 4.0.0+repack-1)
    (Closes: #917788)

 -- Gilles Filippini <pini@debian.org>  Wed, 02 Jan 2019 19:42:17 +0100

med-fichier (4.0.0+repack-3) unstable; urgency=medium

  * Update debian/copyright and add missing copyrights for debian/*
    files
  * Fix debian/watch: use dversionmangle

 -- Gilles Filippini <pini@debian.org>  Mon, 24 Dec 2018 23:33:36 +0100

med-fichier (4.0.0+repack-3~exp1) experimental; urgency=medium

  * Build python packages

 -- Gilles Filippini <pini@debian.org>  Sun, 23 Dec 2018 23:38:15 +0100

med-fichier (4.0.0+repack-2) unstable; urgency=medium

  * New patch build-doc.patch to fix documentation build

 -- Gilles Filippini <pini@debian.org>  Sun, 23 Dec 2018 22:40:59 +0100

med-fichier (4.0.0+repack-2~exp1) experimental; urgency=medium

  * Rename packages to reflect soname bump (closes: #916881):
    - libmed1v5 -> libmed11
    - libmedc1v5 -> libmedc11

 -- Gilles Filippini <pini@debian.org>  Thu, 20 Dec 2018 23:34:28 +0100

med-fichier (4.0.0+repack-1) unstable; urgency=medium

  * Build depends on hdf5 >= 1.10.2 as requested by upstream
  * Enforce ld --as-needed for autopkgtests (closes: #914080)
  * Fix upstream homepage and download links (closes: #856855)
  * Add myself to uploaders

 -- Gilles Filippini <pini@debian.org>  Wed, 19 Dec 2018 11:54:42 +0100

med-fichier (4.0.0+repack-1~exp2) experimental; urgency=medium

  * New patch fix-objects-mount.patch to fix literal 0 used as med_idt
    (fix failing test20.c on 32 bits architectures)

 -- Gilles Filippini <pini@debian.org>  Sat, 15 Dec 2018 00:50:50 +0100

med-fichier (4.0.0+repack-1~exp1) experimental; urgency=medium

  * New upstream release
  * Drop all patches (fixed upstream)

 -- Gilles Filippini <pini@debian.org>  Fri, 14 Dec 2018 19:28:38 +0100

=== debian/control ===
Source: med-fichier
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>,
           "Adam C. Powell, IV" <hazelsct@debian.org>,
           Gilles Filippini <pini@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 11),
               gfortran,
               hdf5-tools (>= 1.10.2),
               libhdf5-mpi-dev (>= 1.10.2),
               mpi-default-dev,
               mpi-default-bin,
               libtool,
               tk,
               dh-python,
               python3-all,
               libpython3-dev,
               swig
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/med-fichier
Vcs-Git: https://salsa.debian.org/science-team/med-fichier.git
Homepage: http://www.salome-platform.org/user-section/about/med
Testsuite: autopkgtest-pkg-python

Package: libmed-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmed11 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for libmed
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.

Package: libmed-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the MED-fichier library
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package provides the documentation for the MED-fichier library
 (in French).

Package: libmed-tools
Architecture: any
Multi-Arch: foreign
Section: science
Depends: tk,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Runtime tools to handle MED files
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains runtime tools for med-fichier:
  - mdump: a tool to dump MED files
  - xmdump: graphical version of mdump.
  - medconforme: a tool to validate a MED file
  - medimport: a tool to convert a MED v2.1 or v2.2 file into a MED v2.3
    file

Package: libmed11
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libmed-doc,
          libmed-tools
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmed1, libmed1v5 (= 4.0.0+repack-1)
Replaces: libmed1, libmed1v5 (= 4.0.0+repack-1)
Description: Library to exchange meshed data (Fortran version)
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the MED-fichier runtime library (Fortran version).

Package: libmedc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libhdf5-mpi-dev,
         libmedc11 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for libmedc
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the header files and static library needed to
 compile applications that use libmedC.

Package: libmedc11
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libmed-doc,
          libmed-tools
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmedc1, libmedc1v5 (= 4.0.0+repack-1)
Replaces: libmedc1, libmedc1v5 (= 4.0.0+repack-1)
Description: Library to exchange meshed data (C version)
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the MED-fichier runtime library (C version).

Package: libmedimport-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmedc-dev,
         libmedimport0v5 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Provides: libmedimportcxx-dev
Description: Development files for libmedimport0
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the header files and static library needed to
 compile applications that use libmedimport, including C++ applications.

Package: libmedimport0v5
Architecture: any
Multi-Arch: same
Section: libs
Depends: libmedc11,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libmed-doc,
          libmed-tools
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmedimport0
Replaces: libmedimport0
Description: Library to import old version files
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the library able to import old version files (C
 version).

Package: python3-med
Architecture: any
Section: python
depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends}
Description: python3 API for MED-fichier
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the Python3 API.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with python3

# Which MPI implementation?
# set ARCH_DEFAULT_MPI_IMPL
include /usr/share/mpi-default-dev/debian_defaults

export OMPI_MCA_orte_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot
export DEB_CPPFLAGS_MAINT_APPEND := -I/usr/include/$(ARCH_DEFAULT_MPI_IMPL) -DOMPI_SKIP_MPICXX=1 -DMPICH_SKIP_MPICXX=1
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

CONFIGURE_FLAGS = --enable-python --with-swig=yes --with-hdf5=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/$(ARCH_DEFAULT_MPI_IMPL) --with-hdf5-bin=/usr/bin

override_dh_auto_clean:
	[ ! -f doc/html.dox/Makefile ] || make -C doc/html.dox maintainer-clean-local
	dh_auto_clean
	rm -fr build.* debian/tmp.*
	[ ! -f doc/dox/examples.dox.orig ] || mv doc/dox/examples.dox.orig doc/dox/examples.dox

override_dh_auto_configure:
	cp doc/dox/examples.dox doc/dox/examples.dox.orig
	PYTHON=/usr/bin/python3 dh_auto_configure -Bbuild.python3 -- $(CONFIGURE_FLAGS)

override_dh_auto_build-arch:
	dh_auto_build -Bbuild.python3

override_dh_auto_build-indep:
	dh_auto_build -Bbuild.python3/doc/html.dox -- html-local

override_dh_auto_install-arch:
	dh_auto_install -Bbuild.python3
	find debian/tmp/usr/lib/python* \( -name \*.py[co] -o -name \*.la \) -delete
	rm -rf debian/tmp/usr/bin/test* \
	       debian/tmp/usr/bin/usescases \
	       debian/tmp/usr/bin/unittests

override_dh_auto_install-indep:
	dh_auto_install -Bbuild.python3/doc/html.dox

override_dh_install:
	dh_install
	rm -f debian/libmedc-dev/usr/include/*import*

override_dh_auto_test-arch:
	MPIEXEC="mpiexec --allow-run-as-root --oversubscribe -np " dh_auto_test -Bbuild.python3/tests/python --max-parallel=1

override_dh_auto_test-indep:

## med-fichier 4.1.0%2Brepack

=== tools/medimport/4.0.0/CMakeLists.txt ===
SET(medimport400_SOURCES
  MAJ_400_410_champs.c
)

FILE(COPY "${PROJECT_SOURCE_DIR}/src/ci/_MEDfieldValueUpdateEntityList41.c" DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})

# On Win platform, we need to make sure symbols are properly exported in
# the intermediary OBJECT targets
# The definition "-D<target>_EXPORTS" is normally added automatically by CMake
# when building Win DLL,
# but this doesn't work when using intermediary targets (ADD_LIBRARY(... OBJECT ...)
IF(WIN32)
  ADD_DEFINITIONS(-Dmedimport_EXPORTS)
ENDIF()

ADD_LIBRARY(_medimport400 OBJECT ${medimport400_SOURCES})

ADD_LIBRARY(_medimport400_static OBJECT ${medimport400_SOURCES})
MED_SET_DEFINITIONS(_medimport400_static MED3_USESTATIC)

=== debian/changelog ===
med-fichier (4.1.0+repack-2) unstable; urgency=medium

  * New patch tests-fix-diff-filters.patch to fix FTBFS against s390x

 -- Gilles Filippini <pini@debian.org>  Tue, 25 Aug 2020 17:51:25 +0200

med-fichier (4.1.0+repack-1) unstable; urgency=medium

  * New upstream release
  * Drop patch fix-objects-mount.patch (fixed upstream)
  * Refresh patch reproducible-builds.patch
  * FFLAGS += -fallow-argument-mismatch to workaround FTBFS with GCC-10

 -- Gilles Filippini <pini@debian.org>  Tue, 25 Aug 2020 11:06:27 +0200

med-fichier (4.0.0+repack-9) unstable; urgency=medium

  * Build for every supported Python 3 release (closes: #945342)

 -- Gilles Filippini <pini@debian.org>  Sun, 24 Nov 2019 18:08:58 +0100
